using Nostr.Client.Messages;

namespace NostrServices.Services.EventHandlers;

public class RedisEventCache : IEventHandler
{
    private readonly RedisStore _redisStore;

    public RedisEventCache(RedisStore redisStore)
    {
        _redisStore = redisStore;
    }

    public async ValueTask HandleEvent(NostrEvent ev)
    {
        if (ev.Kind is NostrKind.Metadata)
        {
            var p = CompactProfile.FromNostrEvent(ev);
            if (p != default)
            {
                await _redisStore.StoreProfile(p);
            }
        }
        else
        {
            await _redisStore.StoreEvent(CompactEvent.FromNostrEvent(ev));
        }
    }
}
